
#from pynrfjprog.API import *
from pynrfjprog import API

from threading import Thread
import time
import math

def printLog(str):
    print str

nrf = API.API(API.DeviceFamily.NRF52)

RSSI = 0
distance = 0

lat_remote_deg = 0
lat_remote_min = 0
lat_remote_indicator = ""
long_remote_deg = 0
long_remote_min = 0
long_remote_indicator = ""
height_remote = 0

lat_local_deg = 0
lat_local_min = 0
lat_local_indicator = ""
long_local_deg = 0
long_local_min = 0
long_local_indicator = ""
height_local = 0

R = 6371    #km

def print_distance_rssi_old(str):
    fix = 0
    for line in lines:
        words = line.split(',')
        if words[0] == 'RSSI':
            RSSI = int(words[1])

        if words[0] == 'GPS_remote':
            if int(words[6]) == 0:
                print "no fix on remote"
                continue

            fix += 1

            if words[2] != "":
                lat_remote_deg = int(words[2][0:2])
                lat_remote_min = float(words[2][2:len(words[2])])
            
            if words[3] != "":
                lat_remote_indicator = words[3]

            if words[4] != "":
                long_remote_deg = int(words[4][0:3])
                long_remote_min = float(words[4][3:len(words[4])])
            
            if words[5] != "":
                long_remote_indicator = words[5]

            if words[9] != "":
                height_remote = float(words[9])

        if words[0] == 'GPS_local':
            if int(words[6]) == 0:
                print "no fix on local"
                continue

            fix += 1

            if words[2] != "":
                lat_local_deg = int(words[2][0:2])
                lat_local_min = float(words[2][2:len(words[2])])
            
            if words[3] != "":
                lat_local_indicator = words[3]

            if words[4] != "":
                long_local_deg = int(words[4][0:3])
                long_local_min = float(words[4][3:len(words[4])])
            
            if words[5] != "":
                long_local_indicator = words[5]

            if words[9] != "":
                height_local = float(words[9])

        
    if fix > 1:
        lat1 = lat_remote_deg + lat_remote_min/60
        lat2 = lat_local_deg + lat_local_min/60

        dlat = math.fabs(lat1 - lat2)
        dlat = math.radians(dlat)

        long1 = long_remote_deg + long_remote_min/60
        long2 = long_local_deg + long_local_min/60

        dlong = math.fabs(long1 - long2)
        dlong = math.radians(dlong)

        lat1 = math.radians(lat1)
        lat2 = math.radians(lat2)

        a = math.sin(dlat/2) * math.sin(dlat/2) + math.sin(dlong/2) * math.sin(dlong/2) * math.cos(lat1) * math.cos(lat2)
        c = 2 * math.atan2(math.sqrt(a), math.sqrt(1-a))
        d = R * c

        distance = d * 1000 + math.fabs(height_local - height_remote)

        print "Local:"
        print "\tCoordinates: ", lat_local_deg, lat_local_min, lat_local_indicator, long_local_deg, long_local_min, long_local_indicator
        print "\tHeight: ", height_local

        print "Remote:"
        print "\tCoordinates", lat_remote_deg, lat_remote_min, lat_remote_indicator, long_remote_deg, long_remote_min, long_remote_indicator
        print "\tHeight: ", height_remote

        print "distance: ", int(distance), "meters"
    print "RSSI: ", RSSI
    print

def print_distance_rssi(str):
    lines = str.split()

    for line in lines:
        words = line.split(':')
        if words[0] == 'RSSI':
            print line
        if words[0] == 'Distance':
            print line

nrf.open()
nrf.connect_to_emu_without_snr()
nrf.sys_reset()
nrf.go()
nrf.rtt_start()
time.sleep(1.1)
# inThread=Thread(target = take_input)
# inThread.deaomnd=True
# inThread.start()
try:
    while True:
        try:
            time.sleep(1.0)
            ret = nrf.rtt_read(0, 2000)
            if ret!="" and len(ret) != 0:
                print_distance_rssi(ret)
        except Exception as e:
            print "Exeption: "+str(e)
            pass
except Exception as e:
    print("An error occurred during printing: " + e.message)
    nrf.rtt_stop()
    nrf.disconnect_from_emu()
    nrf.close()
    exit(0)